;  Must include:
;   name
;   assignmnet #
;   section #

;   No name, asst, section -> no points!


.model medium
.586

; ----------------------------------------------
         
.data

; -----
; Byte Variables

   num1   db   15
   num2   db   7

   res1   db   ?
   res2   db   ?
   res3   dw   ?
   res4   db   ?
   rem4   db   ?

; -----
; Word Variables

   num3   dw   5000
   num4   dw   6

   res5   dw   ?
   res6   dw   ?
   res7   dw   ?
   res8   dw   ?
   rem8   dw   ?

; -----
; Double-word Variables

   num5   dd   100000
   num6   dd   1500

   res9   dd   ?
   res10   dd   ?
   res11   dd   ?
   res12   dd   ?
   rem12   dd   ?


; ----------------------------------------------

.stack   4096
.code

main proc far
   mov  ax, @data
   mov  ds, ax

; ----------
; Byte variables examples
;   res1 = num1 + num2
;   res2 = num1 - num2
;   res3 = num1 * num2
;   res4 = num1 / num2
;   rem4 = modulus(num1/num2)

   mov   al, num1
   add   al, num2
   mov   res1, al

   mov   al, num1
   sub   al, num2
   mov   res2, al

   mov   al, num1
   mul   num2
   mov   res3, ax

   mov   al, num1
   cbw
   div   num2
   mov   res4, al
   mov   rem4, ah

; ----------
; Word variables examples
;   res5 = num3 + num4
;   res6 = num3 - num4
;   res7 = num3 * num4
;   res8 = num3 / num4
;   rem8 = modulus(num3/num4)

   mov   ax, num3
   add   ax, num4
   mov   res5, ax

   mov   ax, num3
   sub   ax, num4
   mov   res6, ax

   mov   ax, num3
   mul   num4
   mov   res7, ax

   mov   ax, num3
   cwd
   div   num4
   mov   res8, ax
   mov   rem8, dx

; ----------
; Double-word variables examples
;   res9 = num5 + num6
;   res10 = num5 - num6
;   res11 = num5 * num6
;   res12 = num5 / num6
;   rem12 = modulus(num5/num6)

   mov   eax, num5
   add   eax, num6
   mov   res9, eax

   mov   eax, num5
   sub   eax, num6
   mov   res10, eax

   mov   eax, num5
   mul   num6
   mov   res11, eax

   mov   eax, num5
   cdq
   div   num6
   mov   res12, eax
   mov   rem12, edx

; ----------
;   Done, terminate program.

last:
   mov  ah, 4ch
   int  21h
main endp

end main 